--코드 6-1 INNER JOIN 실습
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
     , B.BEGIN_TIME
     , B.END_TIME
     , CASE WHEN B.TK_GFF_SE_CD = 'TGS001' THEN '승차'
            WHEN B.TK_GFF_SE_CD = 'TGS002' THEN '하차'
             END TK_GFF_SE_NM
     , B.TK_GFF_CNT
  FROM TB_SUBWAY_STATN A
     , TB_SUBWAY_STATN_TK_GFF B
 WHERE A.SUBWAY_STATN_NO = B.SUBWAY_STATN_NO
   AND A.SUBWAY_STATN_NO = '000001' --1호선 서울역
   AND B.STD_YM = '202010'
   AND B.BEGIN_TIME = '0800'
   AND B.END_TIME = '0900'
 ORDER BY B.TK_GFF_CNT DESC
;

--코드 6-2 실습환경 준비
CREATE TABLE TB_DEPT_6_1_6
(
  DEPT_CD CHAR(4)
, DEPT_NM VARCHAR2(50)
, CONSTRAINT PK_TB_DEPT_6_1_6 PRIMARY KEY(DEPT_CD)
);

INSERT INTO TB_DEPT_6_1_6 (DEPT_CD, DEPT_NM) VALUES ('D001', '데이터팀');
INSERT INTO TB_DEPT_6_1_6 (DEPT_CD, DEPT_NM) VALUES ('D002', '영업팀');
INSERT INTO TB_DEPT_6_1_6 (DEPT_CD, DEPT_NM) VALUES ('D003', 'IT개발팀');

COMMIT;

CREATE TABLE TB_EMP_6_1_6
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50)
, DEPT_CD CHAR(4)
, CONSTRAINT PK_TB_EMP_6_1_6 PRIMARY KEY(EMP_NO)
);

INSERT INTO TB_EMP_6_1_6 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E001', '이경오', 'D001');
INSERT INTO TB_EMP_6_1_6 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E002', '이수지', 'D001');
INSERT INTO TB_EMP_6_1_6 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E003', '김영업', 'D002');
INSERT INTO TB_EMP_6_1_6 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E004', '박영업', 'D002');
INSERT INTO TB_EMP_6_1_6 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E005', '최개발', 'D003');
INSERT INTO TB_EMP_6_1_6 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E006', '정개발', 'D003');

COMMIT;

ALTER TABLE TB_EMP_6_1_6
ADD CONSTRAINT FK_TB_EMP_6_1_6 FOREIGN KEY (DEPT_CD)
REFERENCES TB_DEPT_6_1_6 (DEPT_CD);

--코드 6-3 NATURAL JOIN 실습
SELECT DEPT_CD
     , A.DEPT_NM
     , B.EMP_NO
     , B.EMP_NM
  FROM TB_DEPT_6_1_6 A NATURAL JOIN TB_EMP_6_1_6 B
 ORDER BY DEPT_CD
;

--코드 6-4 NATURAL JOIN을 INNER JOIN으로 변환
SELECT A.DEPT_CD
     , A.DEPT_NM
     , B.EMP_NO
     , B.EMP_NM
  FROM TB_DEPT_6_1_6 A
     , TB_EMP_6_1_6 B
WHERE A.DEPT_CD = B.DEPT_CD
ORDER BY A.DEPT_CD
;

--코드 6-5 USING절 실습
SELECT SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
     , B.BEGIN_TIME
     , B.END_TIME
     , CASE WHEN B.TK_GFF_SE_CD = 'TGS001' THEN '승차'
            WHEN B.TK_GFF_SE_CD = 'TGS002' THEN '하차'
             END TK_GFF_SE_NM
     , B.TK_GFF_CNT
  FROM TB_SUBWAY_STATN A JOIN TB_SUBWAY_STATN_TK_GFF B
 USING (SUBWAY_STATN_NO)
 WHERE SUBWAY_STATN_NO = '000001' --1호선 서울역
   AND B.STD_YM = '202010'
   AND B.BEGIN_TIME = '0800'
   AND B.END_TIME = '0900'
 ORDER BY B.TK_GFF_CNT DESC
;

--코드 6-6 ON절 실습
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
     , B.BEGIN_TIME
     , B.END_TIME
     , CASE WHEN B.TK_GFF_SE_CD = 'TGS001' THEN '승차'
            WHEN B.TK_GFF_SE_CD = 'TGS002' THEN '하차'
             END TK_GFF_SE_NM
     , B.TK_GFF_CNT
  FROM TB_SUBWAY_STATN A
 INNER JOIN TB_SUBWAY_STATN_TK_GFF B
         ON (A.SUBWAY_STATN_NO = B.SUBWAY_STATN_NO)
 WHERE A.SUBWAY_STATN_NO = '000001' --1호선 서울역
   AND B.STD_YM = '202010'
   AND B.BEGIN_TIME = '0800'
   AND B.END_TIME = '0900'
 ORDER BY B.TK_GFF_CNT DESC
;

--코드 6-7 3개의 테이블 조인 - 오라클 방식
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
     , B.BEGIN_TIME
     , B.END_TIME
     , C.TK_GFF_SE_NM
     , B.TK_GFF_CNT
  FROM TB_SUBWAY_STATN A
     , TB_SUBWAY_STATN_TK_GFF B
     , TB_TK_GFF_SE C
 WHERE A.SUBWAY_STATN_NO = B.SUBWAY_STATN_NO
   AND A.SUBWAY_STATN_NO = '000032' --2호선 강남
   AND B.STD_YM = '202010'
   AND B.BEGIN_TIME = '0800'
   AND B.END_TIME = '0900'
   AND B.TK_GFF_SE_CD = C.TK_GFF_SE_CD
 ORDER BY B.TK_GFF_CNT
;

--코드 6-8 3개의 테이블 조인 - ANSI 표준 방식
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
     , B.BEGIN_TIME
     , B.END_TIME
     , C.TK_GFF_SE_NM
     , B.TK_GFF_CNT
  FROM TB_SUBWAY_STATN A
 INNER JOIN TB_SUBWAY_STATN_TK_GFF B
         ON (A.SUBWAY_STATN_NO = B.SUBWAY_STATN_NO)
 INNER JOIN TB_TK_GFF_SE C
         ON(B.TK_GFF_SE_CD = C.TK_GFF_SE_CD)
 WHERE A.SUBWAY_STATN_NO = '000032' --2호선 강남
   AND B.STD_YM = '202010'
   AND B.BEGIN_TIME = '0800'
   AND B.END_TIME = '0900'
 ORDER BY B.TK_GFF_CNT
;

--코드 6-9 OUTER JOIN 실습환경 구축
CREATE TABLE TB_DEPT_6_1_10
(
  DEPT_CD CHAR(4)
, DEPT_NM VARCHAR2(50)
, CONSTRAINT PK_TB_DEPT_6_1_10 PRIMARY KEY(DEPT_CD)
);

INSERT INTO TB_DEPT_6_1_10 (DEPT_CD, DEPT_NM) VALUES ('D001', '데이터팀');
INSERT INTO TB_DEPT_6_1_10 (DEPT_CD, DEPT_NM) VALUES ('D002', '영업팀');
INSERT INTO TB_DEPT_6_1_10 (DEPT_CD, DEPT_NM) VALUES ('D003', 'IT개발팀');
INSERT INTO TB_DEPT_6_1_10 (DEPT_CD, DEPT_NM) VALUES ('D004', '4차산업혁명팀');
INSERT INTO TB_DEPT_6_1_10 (DEPT_CD, DEPT_NM) VALUES ('D005', 'AI연구팀');

COMMIT;

CREATE TABLE TB_EMP_6_1_10
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50)
, DEPT_CD CHAR(4)
, CONSTRAINT PK_TB_EMP_6_1_10 PRIMARY KEY(EMP_NO)
);

INSERT INTO TB_EMP_6_1_10 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E001', '이경오', 'D001');
INSERT INTO TB_EMP_6_1_10 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E002', '이수지', 'D001');
INSERT INTO TB_EMP_6_1_10 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E003', '김영업', 'D002');
INSERT INTO TB_EMP_6_1_10 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E004', '박영업', 'D002');
INSERT INTO TB_EMP_6_1_10 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E005', '최개발', 'D003');
INSERT INTO TB_EMP_6_1_10 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E006', '정개발', 'D003');
INSERT INTO TB_EMP_6_1_10 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E007', '석신입', NULL );
INSERT INTO TB_EMP_6_1_10 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E008', '차인턴', NULL );
INSERT INTO TB_EMP_6_1_10 (EMP_NO, EMP_NM, DEPT_CD) VALUES ('E009', '강회장', 'D000');

COMMIT;

--코드 6-10 LEFT OUTER JOIN - 오라클 DBMS 방식
SELECT NVL(A.DEPT_CD, '(Null)') AS A_DEPT_CD
     , NVL(A.DEPT_NM, '(Null)') AS A_DEPT_NM
     , NVL(B.EMP_NO , '(Null)') AS B_EMP_NO
     , NVL(B.EMP_NM , '(Null)') AS B_EMP_NM
     , NVL(B.DEPT_CD, '(Null)') AS B_DEPT_CD
  FROM TB_DEPT_6_1_10 A, TB_EMP_6_1_10 B
 WHERE A.DEPT_CD = B.DEPT_CD(+)
 ORDER BY A.DEPT_CD
;

--코드 6-11 LEFT OUTER JOIN - ANSI 방식
SELECT NVL(A.DEPT_CD, '(Null)') AS A_DEPT_CD
     , NVL(A.DEPT_NM, '(Null)') AS A_DEPT_NM
     , NVL(B.EMP_NO , '(Null)') AS B_EMP_NO
     , NVL(B.EMP_NM , '(Null)') AS B_EMP_NM
     , NVL(B.DEPT_CD, '(Null)') AS B_DEPT_CD
  FROM TB_DEPT_6_1_10 A
  LEFT OUTER JOIN TB_EMP_6_1_10 B
               ON (A.DEPT_CD = B.DEPT_CD)
 ORDER BY A.DEPT_CD
;

--코드 6-12 RIGHT OUTER JOIN - 오라클 DBMS 방식
SELECT NVL(A.DEPT_CD, '(Null)') AS A_DEPT_CD
     , NVL(A.DEPT_NM, '(Null)') AS A_DEPT_NM
     , NVL(B.EMP_NO , '(Null)') AS B_EMP_NO
     , NVL(B.EMP_NM , '(Null)') AS B_EMP_NM
     , NVL(B.DEPT_CD, '(Null)') AS B_DEPT_CD
  FROM TB_DEPT_6_1_10 A
     , TB_EMP_6_1_10 B
 WHERE A.DEPT_CD(+) = B.DEPT_CD
;

--코드 6-13 RIGHT OUTER JOIN - ANSI 방식
SELECT NVL(A.DEPT_CD, '(Null)') AS A_DEPT_CD
     , NVL(A.DEPT_NM, '(Null)') AS A_DEPT_NM
     , NVL(B.EMP_NO, '(Null)') AS B_EMP_NO
     , NVL(B.EMP_NM, '(Null)') AS B_EMP_NM
     , NVL(B.DEPT_CD, '(Null)') AS B_DEPT_CD
  FROM TB_DEPT_6_1_10 A
 RIGHT OUTER JOIN TB_EMP_6_1_10 B
               ON (A.DEPT_CD = B.DEPT_CD)
 ORDER BY A.DEPT_CD
;


--코드 6-14 FULL OUTER JOIN
SELECT NVL(A.DEPT_CD, '(Null)') AS A_DEPT_CD
     , NVL(A.DEPT_NM, '(Null)') AS A_DEPT_NM
     , NVL(B.EMP_NO , '(Null)') AS B_EMP_NO
     , NVL(B.EMP_NM , '(Null)') AS B_EMP_NM
     , NVL(B.DEPT_CD, '(Null)') AS B_DEPT_CD
  FROM TB_DEPT_6_1_10 A
  FULL OUTER JOIN TB_EMP_6_1_10 B
               ON (A.DEPT_CD = B.DEPT_CD)
;

--코드 6-15 CROSS JOIN - 조인 조건 없는 방식
SELECT ROWNUM AS RNUM
     , NVL(A.DEPT_CD, '(Null)') AS A_DEPT_CD
     , NVL(A.DEPT_NM, '(Null)') AS A_DEPT_NM
     , NVL(B.EMP_NO , '(Null)') AS B_EMP_NO
     , NVL(B.EMP_NM , '(Null)') AS B_EMP_NM
     , NVL(B.DEPT_CD, '(Null)') AS B_DEPT_cD
  FROM TB_DEPT_6_1_10 A
     , TB_EMP_6_1_10 B
 ORDER BY RNUM
;

--코드 6-16 CROSS JOIN - ANSI 표준 방식
SELECT ROWNUM AS RNUM
     , NVL(A.DEPT_CD, '(Null)') AS A_DEPT_CD
     , NVL(A.DEPT_NM, '(Null)') AS A_DEPT_NM
     , NVL(B.EMP_NO , '(Null)') AS B_EMP_NO
     , NVL(B.EMP_NM , '(Null)') AS B_EMP_NM
     , NVL(B.DEPT_CD, '(Null)') AS B_DEPT_CD
  FROM TB_DEPT_6_1_10 A
 CROSS JOIN TB_EMP_6_1_10 B
 ORDER BY RNUM
;

--코드 6-17 복제용 임시 테이블 생성
CREATE TABLE TB_COPY_3
(
  COPY_NUM NUMBER
, CONSTRAINT PK_TB_COPY_3 PRIMARY KEY (COPY_NUM)
)
;

INSERT INTO TB_COPY_3 (COPY_NUM) VALUES (1);
INSERT INTO TB_COPY_3 (COPY_NUM) VALUES (2);
INSERT INTO TB_COPY_3 (COPY_NUM) VALUES (3);

COMMIT;

--코드 6-18 CROSS JOIN을 이용한 데이터 복제
SELECT A.INDUTY_CL_SE_CD
     , A.INDUTY_CL_SE_NM
     , B.COPY_NUM AS 집합번호
  FROM TB_INDUTY_CL_SE A
 CROSS JOIN TB_COPY_3 B
 ORDER BY B.COPY_NUM, A.INDUTY_CL_SE_CD
;