--SQL*Plus 접속 - SYSTEM
sqlplus SYSTEM/1234
--코드 6-71 새로운 사용자 계정 생성
CREATE USER DCL_TEST IDENTIFIED BY 1234;
--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - DCL_TEST
sqlplus DCL_TEST/1234

--SQL*Plus 접속 - SYSTEM
sqlplus SYSTEM/1234

--코드 6-72 접속 권한 부여
GRANT CREATE SESSION TO DCL_TEST;

sqlplus DCL_TEST/1234

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - DCL_TEST
sqlplus DCL_TEST/1234


--코드 6-73 테이블 생성 시도
CREATE TABLE TB_DCL_TEST
(
  DCL_TEST_NO CHAR(10)
, DCL_TEST_NM VARCHAR2(50)
, CONSTRAINT PK_TB_DCL_TEST PRIMARY KEY(DCL_TEST_NO)
)
;

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - SYSTEM
sqlplus SYSTEM/1234

--코드 6-74 테이블 생성 권한 부여
GRANT CREATE TABLE TO DCL_TEST;

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - DCL_TEST
sqlplus DCL_TEST/1234

--코드 6-75 테이블 생성
CREATE TABLE TB_DCL_TEST
(
  DCL_TEST_NO CHAR(10)
, DCL_TEST_NM VARCHAR2(50)
, CONSTRAINT PK_TB_DCL_TEST PRIMARY KEY(DCL_TEST_NO)
)
;

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - DCL_TEST
sqlplus DCL_TEST/1234

--코드 6-76 테이블 조회
SELECT * FROM SQLD.TB_ADRES_CL_SE;

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - SYSTEM
sqlplus SYSTEM/1234

--코드 6-77 테이블 조회 권한 부여
GRANT SELECT ON SQLD.TB_ADRES_CL_SE TO DCL_TEST;

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - DCL_TEST
sqlplus DCL_TEST/1234

--코드 6-78 테이블 조회
SELECT * FROM SQLD.TB_ADRES_CL_SE;

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - SYSTEM
sqlplus SYSTEM/1234

--코드 6-79 테이블 DML 권한 주기
GRANT INSERT, DELETE, UPDATE ON SQLD.TB_ADRES_CL_SE TO DCL_TEST;

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - DCL_TEST
sqlplus DCL_TEST/1234

--코드 6-80 데이터 입력, 수정, 삭제
INSERT INTO SQLD.TB_ADRES_CL_SE (ADRES_CL_SE_CD, ADRES_CL_SE_NM ) VALUES ('999999', 'INSERT테스트');

COMMIT;

UPDATE SQLD.TB_ADRES_CL_SE
   SET ADRES_CL_SE_NM = 'UPDATE테스트'
  WHERE ADRES_CL_SE_CD = '999999'
;

COMMIT;

DELETE SQLD.TB_ADRES_CL_SE
 WHERE ADRES_CL_SE_CD = '999999'
;

COMMIT;

--SQL*Plus 접속 종료
SQL> quit


--SQL*Plus 접속 - SYSTEM
sqlplus SYSTEM/1234

--코드 6-81 테이블 DML 권한 회수
REVOKE SELECT ON SQLD.TB_ADRES_CL_SE FROM DCL_TEST;
REVOKE INSERT, DELETE, UPDATE ON SQLD.TB_ADRES_CL_SE FROM DCL_TEST;
REVOKE CREATE TABLE FROM DCL_TEST;

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - DCL_TEST
sqlplus DCL_TEST/1234

--코드 6-82 테이블 생성
CREATE TABLE TB_DCL_TEST
(
  DCL_TEST_NO CHAR(10)
, DCL_TEST_NM VARCHAR2(50)
, CONSTRAINT PK_TB_DCL_TEST PRIMARY KEY(DCL_TEST_NO)
)
;

--SQL*Plus 접속 - SYSTEM
sqlplus SYSTEM/1234

--코드 6-83 접속 권한 회수
REVOKE CREATE SESSION FROM DCL_TEST;

--코드 6-84 테이블 제거
DROP TABLE DCL_TEST.TB_DCL_TEST;

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - SYSTEM
sqlplus SYSTEM/1234

--코드 6-85 ROLE 생성
CREATE ROLE CREATE_SESSION_TABLE;

--코드 6-86 ROLE에 권한 추가
GRANT CREATE SESSION, CREATE TABLE TO CREATE_SESSION_TABLE;

--코드 6-87 사용자에게 ROLE 권한 부여
GRANT CREATE_SESSION_TABLE TO DCL_TEST;

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - DCL_TEST
sqlplus DCL_TEST/1234

--코드 6-88 테이블 생성 시도
CREATE TABLE TB_DCL_TEST
(
  DCL_TEST_NO CHAR(10)
, DCL_TEST_NM VARCHAR2(50)
, CONSTRAINT PK_TB_DCL_TEST PRIMARY KEY(DCL_TEST_NO)
)
;

--SQL*Plus 접속 종료
SQL> quit


--SQL*Plus 접속 - SYSTEM
sqlplus SYSTEM/1234

--코드 6-89 사용자 계정 제거 및 재생성
DROP USER DCL_TEST CASCADE; --생성한 테이블도 같이 제거됨
CREATE USER DCL_TEST IDENTIFIED BY 1234;
GRANT CONNECT, RESOURCE TO DCL_TEST;

--SQL*Plus 접속 종료
SQL> quit

--SQL*Plus 접속 - DCL_TEST
sqlplus DCL_TEST/1234

--코드 6-90 테이블 생성
CREATE TABLE TB_DCL_TEST
(
  DCL_TEST_NO CHAR(10)
, DCL_TEST_NM VARCHAR2(50)
, CONSTRAINT PK_TB_DCL_TEST PRIMARY KEY(DCL_TEST_NO)
)
;
