

--코드 7-4 테이블 생성 및 복제
CREATE TABLE TB_BSSH_TMP AS
SELECT * FROM TB_BSSH;

--코드 7-5 테이블 통계정보 수집
ANALYZE TABLE TB_BSSH_TMP COMPUTE STATISTICS;

--코드 7-6 인덱스 생성
CREATE INDEX IDX_TB_BSSH_TMP_01 ON TB_BSSH_TMP(ADSTRD_CD);

--코드 7-7 인덱스 통계정보 생성
ANALYZE INDEX IDX_TB_BSSH_TMP_01 ESTIMATE STATISTICS;

--코드 7-8 통계레벨 설정
ALTER SESSION SET STATISTICS_LEVEL = ALL;

--코드 7-9 SQL문 실행
SELECT /* SELECT.TB_BSSH_TMP.001 */
       A.BSSH_NO
     , A.CMPNM_NM
     , A.INDUTY_SMALL_CL_CD
     , A.ADSTRD_CD
     , A.LNM_ADRES
     , A.NW_ZIP
     , A.LO
     , A.LA
  FROM TB_BSSH_TMP A
 WHERE A.ADSTRD_CD = '4128157000' --경기도 고양시 덕양구 삼송동
ORDER BY A.ADSTRD_CD
;

--코드 7-10 SQL 실행 정보 조회
SELECT SQL_ID
     , CHILD_NUMBER
     , SUBSTR(SQL_FULLTEXT, 1, 60)
  FROM V$SQL
  WHERE SQL_FULLTEXT LIKE '%SELECT.TB_BSSH_TMP.001%'
    AND SQL_FULLTEXT NOT LIKE '%V$SQL%'
  ORDER BY LAST_ACTIVE_TIME DESC
;

--코드 7-11 실행내역 확인
SELECT *
FROM TABLE (DBMS_XPLAN.DISPLAY_CURSOR('c5s4sva27qmdr' ,0, 'ALLSTATS LAST -ROWS'))
;


--코드 7-12 지하철역승하차_임시 테이블 생성
CREATE TABLE TB_SUBWAY_STATN_TK_GFF_TMP AS
SELECT * FROM TB_SUBWAY_STATN_TK_GFF
;

--코드 7-13 테이블 통계정보 수집
ANALYZE TABLE TB_SUBWAY_STATN_TK_GFF_TMP COMPUTE STATISTICS;

--코드 7-14 지하철역승하차임시 테이블에 기본키 생성
ALTER TABLE TB_SUBWAY_STATN_TK_GFF_TMP
ADD CONSTRAINT PK_TB_SUBWAY_STATN_TK_GFF_TMP
PRIMARY KEY(SUBWAY_STATN_NO , STD_YM, BEGIN_TIME, END_TIME, TK_GFF_SE_CD)
;

--코드 7-15 기본키에 대한 통계정보 수집
ANALYZE INDEX PK_TB_SUBWAY_STATN_TK_GFF_TMP ESTIMATE STATISTICS;

--코드 7-16 통계레벨 설정
ALTER SESSION SET STATISTICS_LEVEL = ALL;


--코드 7-17 SQL문 실행
SELECT /* SELECT.TB_SUBWAY_STATN_TK_GFF_TMP.001 */
       A.SUBWAY_STATN_NO
     , A.STD_YM
     , A.BEGIN_TIME
     , A.END_TIME
     , A.TK_GFF_SE_CD
     , A.TK_GFF_CNT
  FROM TB_SUBWAY_STATN_TK_GFF_TMP A
 WHERE A.SUBWAY_STATN_NO = '000376' --일산선 삼송역
   AND A.STD_YM = '202010'
   AND A.BEGIN_TIME = '0700'
   AND A.END_TIME = '0800'
   AND A.TK_GFF_SE_CD = 'TGS001'
;

--코드 7-18 인덱스 생성
CREATE INDEX IDX_TB_SUB_STA_TK_GFF_TMP_02
ON TB_SUBWAY_STATN_TK_GFF_TMP (STD_YM, BEGIN_TIME);

--코드 7-19 통계정보 생성
ANALYZE INDEX IDX_TB_SUB_STA_TK_GFF_TMP_02 ESTIMATE STATISTICS;

--코드 7-20 통계레벨 설정
ALTER SESSION SET STATISTICS_LEVEL = ALL;

--코드 7-21 SQL문 실행
SELECT /*+ INDEX(A IDX_TB_SUBWAY_STATN_TK_GFF_TMP_02) */
       /* SELECT.TB_SUBWAY_STATN_TK_GFF_TMP.003 */
       A.STD_YM
     , A.BEGIN_TIME
  FROM TB_SUBWAY_STATN_TK_GFF_TMP A
  WHERE A.BEGIN_TIME >= '0200'
  ORDER BY A.STD_YM
;

--코드 7-22 인덱스 생성
CREATE INDEX IDX_TB_SUB_STA_TK_GFF_TMP_03 ON TB_SUBWAY_STATN_TK_GFF_TMP
(TK_GFF_SE_CD, SUBWAY_STATN_NO);

--코드 7-23 통계정보 생성
ANALYZE INDEX IDX_TB_SUB_STA_TK_GFF_TMP_03 ESTIMATE STATISTICS;

--코드 7-24 통계레벨 설정
ALTER SESSION SET STATISTICS_LEVEL = ALL;

--코드 7-25 인덱스 스킵 스캔 유도
SELECT /*+ INDEX_SS(A IDX_TB_SUB_STA_TK_GFF_TMP_03) */
       /* SELECT.TB_SUBWAY_STATN_TK_GFF_TMP.004 */
       A.SUBWAY_STATN_NO
     , A.STD_YM
     , A.BEGIN_TIME
     , A.END_TIME
     , A.TK_GFF_SE_CD
     , A.TK_GFF_CNT
  FROM TB_SUBWAY_STATN_TK_GFF_TMP A
  WHERE A.SUBWAY_STATN_NO = '000376'
;

--코드 7-26 인덱스 생성
CREATE INDEX IDX_TB_SUB_STA_TK_GFF_TMP_04
ON TB_SUBWAY_STATN_TK_GFF_TMP(STD_YM, BEGIN_TIME, END_TIME);

--코드 7-27 통계정보 생성
ANALYZE INDEX IDX_TB_SUB_STA_TK_GFF_TMP_04 ESTIMATE STATISTICS;

--코드 7-28 통계레벨 설정
ALTER SESSION SET STATISTICS_LEVEL = ALL;

--코드 7-29 SQL문 실행
SELECT /*+ INDEX_FFS(A IDX_TB_SUB_STA_TK_GFF_TMP_04) */
       /* SELECT.TB_SUBWAY_STATN_TK_GFF_TMP.005 */
        A.STD_YM
      , MAX(A.BEGIN_TIME) AS BEGIN_TIME
      , MAX(A.END_TIME) AS END_TIME
   FROM TB_SUBWAY_STATN_TK_GFF_TMP A
  WHERE A.STD_YM >= '00000000'
  GROUP BY A.STD_YM
;

--코드 7-30 인덱스 생성
CREATE INDEX IDX_TB_SUB_STA_TK_GFF_TMP_05
ON TB_SUBWAY_STATN_TK_GFF_TMP(STD_YM, END_TIME);


--코드 7-31 통계정보 수집
ANALYZE INDEX IDX_TB_SUB_STA_TK_GFF_TMP_05 ESTIMATE STATISTICS;

--코드 7-32 통계레벨 설정
ALTER SESSION SET STATISTICS_LEVEL = ALL;

--코드 7-33 SQL문 실행
SELECT /*+ INDEX_DESC(A IDX_TB_SUB_STA_TK_GFF_TMP_05) */
       /* SELECT.TB_SUBWAY_STATN_TK_GFF_TMP.006 */
       A.SUBWAY_STATN_NO
     , A.STD_YM
     , A.BEGIN_TIME
     , A.END_TIME
     , A.TK_GFF_SE_CD
     , A.TK_GFF_CNT
  FROM TB_SUBWAY_STATN_TK_GFF_TMP A
 WHERE A.STD_YM = '202010'
   AND A.END_TIME <= '1800'
 ORDER BY A.STD_YM, END_TIME DESC
;