--코드 8-18 GROUP BY + HAVING절
SELECT POPLTN_SE_CD
     , SUM(POPLTN_CNT) AS POPLTN_CNT_SUM
  FROM TB_POPLTN
 GROUP BY POPLTN_SE_CD
HAVING POPLTN_SE_CD IN ('M', 'F')
 ORDER BY POPLTN_CNT_SUM DESC
;

--코드 8-19 HAVING + GROUP BY절
SELECT POPLTN_SE_CD
     , SUM(POPLTN_CNT) AS POPLTN_CNT_SUM
  FROM TB_POPLTN
HAVING POPLTN_SE_CD IN ('M', 'F')
 GROUP BY POPLTN_SE_CD
 ORDER BY POPLTN_CNT_SUM DESC
;

--코드 8-20 GROUP BY 없이 HAVING만을 사용한 SQL문
SELECT POPLTN_SE_CD
     , SUM(POPLTN_CNT) AS POPLTN_CNT_SUM
  FROM TB_POPLTN
HAVING POPLTN_SE_CD IN ('M', 'F')
ORDER BY POPLTN_CNT_SUM DESC
;

--코드 8-21 GROUP BY절 사용
SELECT POPLTN_SE_CD
     , SUM(POPLTN_CNT) POPLTN_CNT_SUM
  FROM TB_POPLTN
 GROUP BY POPLTN_SE_CD
 ORDER BY POPLTN_SE_CD
;

--코드 8-22 GROUP BY절에 기재한 칼럼을 SELECT절에 기재하지 않음 - 정상 작동
SELECT SUM(POPLTN_CNT) POPLTN_CNT_SUM
  FROM TB_POPLTN
 GROUP BY POPLTN_SE_CD
 ORDER BY POPLTN_SE_CD;
;

--코드 8-23 GROUP BY절을 이용한 SQL문
SELECT POPLTN_SE_CD
     , SUM(POPLTN_CNT) AS POPLTN_CNT_SUM
  FROM TB_POPLTN
 GROUP BY POPLTN_SE_CD
 ORDER BY POPLTN_CNT_SUM
;

--코드 8-24 GROUP BY절을 이용한 SQL문 - 에러 발생
SELECT POPLTN_SE_CD
     , SUM(POPLTN_CNT) AS POPLTN_CNT_SUM
  FROM TB_POPLTN
 GROUP BY POPLTN_SE_CD
 ORDER BY POPLTN_CNT
;

--코드 8-25 GROUP BY절을 이용한 SQL문 - 에러 발생
SELECT POPLTN_SE_CD
     , SUM(POPLTN_CNT) AS POPLTN_CNT_SUM
  FROM TB_POPLTN
 GROUP BY POPLTN_SE_CD
 ORDER BY ADSTRD_CD
;

--코드 8-26 GROUP BY절을 이용한 SQL문 - 정상 실행
SELECT POPLTN_SE_CD
     , SUM(POPLTN_CNT) AS POPLTN_CNT_SUM
  FROM TB_POPLTN
 GROUP BY POPLTN_SE_CD
 ORDER BY POPLTN_SE_CD, SUM(POPLTN_CNT), POPLTN_CNT_SUM
;

--코드 8-27 실습환경 구성
CREATE TABLE TB_EMP_8_3_4
(
  EMP_NO CHAR(10)
, EMP_NM VARCHAR2(20) NULL
, CUR_SAL NUMBER(15) NOT NULL
, DEPT_CD CHAR(6) NULL
, CONSTRAINT PK_TB_EMP_8_3_4 PRIMARY KEY(EMP_NO)
)
;

INSERT INTO TB_EMP_8_3_4 VALUES('1000000001', '이부장', 70000000, 'D00001');
INSERT INTO TB_EMP_8_3_4 VALUES('1000000002', '김팀장', 65000000, 'D00001');
INSERT INTO TB_EMP_8_3_4 VALUES('1000000003', '박과장', 55000000, 'D00002');
INSERT INTO TB_EMP_8_3_4 VALUES('1000000004', '최대리', 45000000, 'D00002');
INSERT INTO TB_EMP_8_3_4 VALUES('1000000005', '최임시', 35000000, NULL );
INSERT INTO TB_EMP_8_3_4 VALUES('1000000006', '손인턴', 25000000, NULL );

COMMIT;

--코드 8-28 GROUP BY의 사용
SELECT NVL(DEPT_CD, '[NULL]') AS DEPT_CD
     , TRUNC(AVG(CUR_SAL)) AS CUR_SAL_AVG
  FROM TB_EMP_8_3_4
 GROUP BY DEPT_CD
 ORDER BY DEPT_CD
;

--코드 8-29 실습환경 구성
CREATE TABLE TB_ORD_8_3_5
(
  ORD_NO CHAR(10)
, ORD_DE CHAR(8)
, ORD_AMT NUMBER
, ADD_AMT number
, ORD_MM CHAR(6)
);

INSERT INTO TB_ORD_8_3_5 VALUES('0000000001', '20200101', 500, 50, '202001');

COMMIT;

--코드 8-30 공집합이 나오는 SELECT문
SELECT ORD_AMT
  FROM TB_ORD_8_3_5
 WHERE ORD_MM = '202010'
;

--코드 8-31 집계 함수로 감싸서 공집합이 나오는 것을 방지
SELECT NVL(MAX(ORD_AMT), 0) AS ORD_AMT_MAX
  FROM TB_ORD_8_3_5
 WHERE ORD_MM = '202010'
;

--코드 8-32 GROUP BY를 추가
SELECT NVL(MAX(ORD_AMT), 0) AS ORD_AMT_MAX
  FROM TB_ORD_8_3_5
 WHERE ORD_MM = '202010'
 GROUP BY ORD_MM
;

