--코드 8-33 UNION ALL을 이용한 SQL문
SELECT '2번째SELECT문' AS TEXT FROM DUAL
UNION ALL
SELECT '1번째SELECT문' AS TEXT FROM DUAL
;

--코드 8-34 UNION ALL + ORDER BY절을 이용한 SQL문
SELECT '2번째SELECT문' AS TEXT FROM DUAL
UNION ALL
SELECT '1번째SELECT문' AS TEXT FROM DUAL
ORDER BY TEXT;

--코드 8-35 UNION ALL 이용 시 헤더명 지정 및 ORDER BY 1 사용
SELECT A.SUBWAY_STATN_NO AS "지하철역번호"
     , A.LN_NM AS "노선명"
     , A.STATN_NM AS "역명"
  FROM TB_SUBWAY_STATN A WHERE STATN_NM = '강남'
UNION ALL
SELECT B.SUBWAY_STATN_NO
     , B.LN_NM
     , B.STATN_NM
  FROM TB_SUBWAY_STATN B WHERE STATN_NM = '역삼'
UNION ALL
SELECT C.SUBWAY_STATN_NO
     , C.LN_NM
     , C.STATN_NM
  FROM TB_SUBWAY_STATN C WHERE STATN_NM = '선릉'
 ORDER BY 1
;

--코드 8-36 UNION ALL 이용 시 헤더명 지정 및 ORDER BY절에 앨리어스 사용
SELECT A.SUBWAY_STATN_NO AS "지하철역번호"
     , A.LN_NM AS "노선명"
     , A.STATN_NM AS "역명"
  FROM TB_SUBWAY_STATN A WHERE STATN_NM = '강남'
UNION ALL
SELECT B.SUBWAY_STATN_NO
     , B.LN_NM
     , B.STATN_NM
  FROM TB_SUBWAY_STATN B WHERE STATN_NM = '역삼'
UNION ALL
SELECT C.SUBWAY_STATN_NO
     , C.LN_NM
     , C.STATN_NM
  FROM TB_SUBWAY_STATN C WHERE STATN_NM = '선릉'
ORDER BY "지하철역번호"
;

--코드 8-37 UNION ALL 이용 시 헤더명 지정 및 ORDER BY절에 칼럼명 사용
SELECT A.SUBWAY_STATN_NO AS "지하철역번호"
     , A.LN_NM AS "노선명"
     , A.STATN_NM AS "역명"
  FROM TB_SUBWAY_STATN A WHERE STATN_NM = '강남'
UNION ALL
SELECT B.SUBWAY_STATN_NO
     , B.LN_NM
     , B.STATN_NM
  FROM TB_SUBWAY_STATN B
 WHERE STATN_NM = '역삼'
UNION ALL
SELECT C.SUBWAY_STATN_NO
     , C.LN_NM
     , C.STATN_NM
  FROM TB_SUBWAY_STATN C
 WHERE STATN_NM = '선릉'
ORDER BY SUBWAY_STATN_NO
;

--코드 8-38 일반적인 SQL문
SELECT A.STATN_NM
  FROM TB_SUBWAY_STATN A
 WHERE A.STATN_NM = '선릉'
;

--코드 8-39 MINUS 연산 수행
SELECT A.STATN_NM
  FROM TB_SUBWAY_STATN A
 WHERE A.STATN_NM = '선릉'
MINUS
SELECT A.STATN_NM
  FROM TB_SUBWAY_STATN A
 WHERE A.STATN_NM = '강남'
;

